Crypto++

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes
GCM_Base::GCTR Class Reference

Inherits CipherModeFinalTemplate_ExternalCipher< ConcretePolicyHolder< Empty, AdditiveCipherTemplate< AbstractPolicyHolder< AdditiveCipherAbstractPolicy, CTR_ModePolicy > > > >.

List of all members.

## Public Types

typedef AbstractPolicyHolder < AdditiveCipherAbstractPolicy, CTR_ModePolicy > ::PolicyInterface | PolicyInterface
enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }

## Public Member Functions

std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
void | GenerateBlock (byte *output, size_t size)
| generate random array of bytes
void | ProcessData (byte *outString, const byte *inString, size_t length)
| encrypt or decrypt an array of bytes of specified length
void | Resynchronize (const byte *iv, int length=-1)
| resynchronize with an IV. ivLength=-1 means use IVSize()
unsigned int | OptimalBlockSize () const
| returns the input block size that is most efficient for this cipher
unsigned int | GetOptimalNextBlockSize () const
unsigned int | OptimalDataAlignment () const
| returns how input should be aligned for optimal performance
bool | IsSelfInverting () const
| returns whether this transformation is self-inverting (e.g. xor with a keystream)
bool | IsForwardTransformation () const
| returns whether this is an encryption object
bool | IsRandomAccess () const
| returns whether this cipher supports random access
void | Seek (lword position)
| for random access ciphers, seek to an absolute position
bool | CipherIsRandomAccess () const
IV_Requirement | IVRequirement () const
| returns the minimal requirement for secure IVs
size_t | MinKeyLength () const
| returns smallest valid key length in bytes */
size_t | MaxKeyLength () const
| returns largest valid key length in bytes */
size_t | DefaultKeyLength () const
| returns default (recommended) key length in bytes */
size_t | GetValidKeyLength (size_t n) const
| returns the smallest valid key length in bytes that is >= min(n, GetMaxKeyLength())
bool | IsValidKeyLength (size_t n) const
| returns whether n is a valid key length
unsigned int | IVSize () const
void | SetCipher (BlockCipher &cipher)
void | SetCipherWithIV (BlockCipher &cipher, const byte *iv, int feedbackSize=0)
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| set or reset the key of this object
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| calls SetKey() with an NameValuePairs object that just specifies "Rounds"
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| calls SetKey() with an NameValuePairs object that just specifies "IV"
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| calls SetKey() with an NameValuePairs object that just specifies "IV"
bool | IsResynchronizable () const
| returns whether this object can be resynchronized (i.e. supports initialization vectors)
bool | CanUseRandomIVs () const
| returns whether this object can use random IVs (in addition to ones returned by GetNextIV)
bool | CanUsePredictableIVs () const
| returns whether this object can use random but possibly predictable IVs (in addition to ones returned by GetNextIV)
bool | CanUseStructuredIVs () const
| returns whether this object can use structured IVs, for example a counter (in addition to ones returned by GetNextIV)
unsigned int | DefaultIVLength () const
| returns default length of IVs accepted by this object
virtual unsigned int | MinIVLength () const
| returns minimal length of IVs accepted by this object
virtual unsigned int | MaxIVLength () const
| returns maximal length of IVs accepted by this object
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *IV)
| get a secure IV for the next message
StreamTransformation & | Ref ()
| return a reference to this object, useful for passing a temporary object to a function that takes a non-const reference
virtual unsigned int | MandatoryBlockSize () const
| returns block size, if input must be processed in blocks, otherwise 1
virtual unsigned int | GetOptimalBlockSizeUsed () const
| returns how much of the current block is used up
virtual void | ProcessLastBlock (byte *outString, const byte *inString, size_t length)
| for ciphers where the last block of data is special, encrypt or decrypt the last block of data
virtual unsigned int | MinLastBlockSize () const
| returns the minimum size of the last block, 0 indicating the last block is not special
void | ProcessString (byte *inoutString, size_t length)
| same as ProcessData(inoutString, inoutString, length)
void | ProcessString (byte *outString, const byte *inString, size_t length)
| same as ProcessData(outString, inString, length)
byte | ProcessByte (byte input)
| implemented as {ProcessData(&input, &input, 1); return input;}
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
virtual unsigned int | GetOptimalBlockSize () const
virtual void | IncorporateEntropy (const byte *input, size_t length)
| update RNG state with additional unpredictable values
virtual bool | CanIncorporateEntropy () const
| returns true if IncorporateEntropy is implemented
virtual byte | GenerateByte ()
| generate new random byte and return it
virtual unsigned int | GenerateBit ()
| generate new random bit and return it
virtual word32 | GenerateWord32 (word32 a=0, word32 b=0xffffffffL)
| generate a random 32 bit word in the range min to max, inclusive
virtual void | DiscardBytes (size_t n)
| generate and discard n bytes
virtual void | GenerateIntoBufferedTransformation (BufferedTransformation &target, const std::string &channel, lword length)
| generate random bytes as input to a BufferedTransformation
template<class IT >
void | Shuffle (IT begin, IT end)
| randomly shuffle the specified array, resulting permutation is uniformly distributed

## Static Public Member Functions

static const char * | StaticAlgorithmName ()

## Protected Member Functions

void | IncrementCounterBy256 ()
const typename AdditiveCipherTemplate < AbstractPolicyHolder < AdditiveCipherAbstractPolicy, CTR_ModePolicy > >::PolicyInterface & | GetPolicy () const
typename AdditiveCipherTemplate < AbstractPolicyHolder < AdditiveCipherAbstractPolicy, CTR_ModePolicy > >::PolicyInterface & | AccessPolicy ()
void | UncheckedSetKey (const byte *key, unsigned int length, const NameValuePairs &params)
unsigned int | GetBufferByteSize (const PolicyInterface &policy) const
byte * | KeystreamBufferBegin ()
byte * | KeystreamBufferEnd ()
unsigned int | GetAlignment () const
unsigned int | GetBytesPerIteration () const
unsigned int | GetIterationsToBuffer () const
void | WriteKeystream (byte *buffer, size_t iterationCount)
bool | CanOperateKeystream () const
void | OperateKeystream (KeystreamOperation operation, byte *output, const byte *input, size_t iterationCount)
void | CipherResynchronize (byte *keystreamBuffer, const byte *iv, size_t length)
void | SeekToIteration (lword iterationCount)
unsigned int | BlockSize () const
virtual void | SetFeedbackSize (unsigned int feedbackSize)
virtual void | ResizeBuffers ()
const Algorithm & | GetAlgorithm () const
void | ThrowIfInvalidKeyLength (size_t length)
void | ThrowIfResynchronizable ()
void | ThrowIfInvalidIV (const byte *iv)
size_t | ThrowIfInvalidIVLength (int size)
const byte * | GetIVAndThrowIfInvalid (const NameValuePairs &params, size_t &size)
void | AssertValidKeyLength (size_t length) const

## Protected Attributes

SecByteBlock | m_buffer
size_t | m_leftOver
AlignedSecByteBlock | m_counterArray
BlockCipher * | m_cipher
AlignedSecByteBlock | m_register

## Detailed Description

Definition at line 68 of file gcm.h.

## Member Function Documentation

void AdditiveCipherTemplate< AbstractPolicyHolder< AdditiveCipherAbstractPolicy, CTR_ModePolicy > >::ProcessData | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length
| ) |  | `[virtual, inherited]`

Implements StreamTransformation.

unsigned int AdditiveCipherTemplate< AbstractPolicyHolder< AdditiveCipherAbstractPolicy, CTR_ModePolicy > >::OptimalBlockSize | ( |  | ) | const`[inline, virtual, inherited]`

Reimplemented from StreamTransformation.

Definition at line 140 of file strciphr.h.

virtual void SimpleKeyingInterface::SetKey | ( | const byte * | key,
|  | size_t | length,
|  | const NameValuePairs & | params = `g_nullNameValuePairs`
| ) |  | `[virtual, inherited]`

set or reset the key of this object

Parameters:

  params | is used to specify Rounds, BlockSize, etc.

Reimplemented in ECB_OneWay, and AuthenticatedSymmetricCipherBase.

bool SimpleKeyingInterface::IsResynchronizable | ( |  | ) | const`[inline, inherited]`

returns whether this object can be resynchronized (i.e. supports initialization vectors)

If this function returns true, and no IV is passed to SetKey() and CanUseStructuredIVs()==true, an IV of all 0's will be assumed.

Definition at line 385 of file cryptlib.h.

virtual void SimpleKeyingInterface::GetNextIV | ( | RandomNumberGenerator & | rng,
|  | byte * | IV
| ) |  | `[virtual, inherited]`

get a secure IV for the next message

This method should be called after you finish encrypting one message and are ready to start the next one. After calling it, you must call SetKey() or Resynchronize() before using this object again. This method is not implemented on decryption objects.

Reimplemented in VMAC_Base.

virtual void StreamTransformation::ProcessLastBlock | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length
| ) |  | `[virtual, inherited]`

for ciphers where the last block of data is special, encrypt or decrypt the last block of data

For now the only use of this function is for CBC-CTS mode.

Reimplemented in CBC_CTS_Decryption, and CBC_CTS_Encryption.

virtual unsigned int RandomNumberGenerator::GenerateBit | ( |  | ) | `[virtual, inherited]`

generate new random bit and return it

Default implementation is to call GenerateByte() and return its lowest bit.

Reimplemented in PublicBlumBlumShub.

The documentation for this class was generated from the following file:

- gcm.h